package de.mutschler.rpdl.calc;

import de.mutschler.rpdl.*;
import de.mutschler.rpdl.entity.*;

/**
 * This class simply performs a recalculation of a statement.
 */

public class CalcStmt extends CalcItem
{
	/** The attribute to calculate. */
	private StmtHandle stmtHandle;
	
	public CalcStmt(StmtHandle sh) {
		this.stmtHandle = sh;
	}

	/** Get the statement handle. */
	public StmtHandle getStmtHandle() {return stmtHandle;}

	/** execute this calculation. Call the calculation method of the attribute. */
	protected void execute(RpdlBase main) throws RpdlException {
		stmtHandle.getStatement().execute(main, stmtHandle.getObject());
	}

	/** This is to specify the order of execution.
	 * returns a negative number if this object should be executed before the passed
	 * object.
	 * return 0 if the order doesn't matter
	 * return positive number, if this object must be executed after the passed object.
	 */
	public int compareTo(CalcStmt cs) {
		return 0;	// by default no comparison can be done
	}


	public boolean equals(Object o) {
		if (o instanceof CalcStmt) 
			return stmtHandle.equals(((CalcStmt)o).getStmtHandle());
		return false;
	}
	
	public String toString() {
		return "Calc Stmt: " + getStmtHandle();
	}
}