package de.mutschler.rpdl.command;

import de.mutschler.rpdl.*;
import de.mutschler.rpdl.entity.*;
import java.util.*;

public class CmdBase extends RpdlCommand implements java.io.Serializable
{
	static final long serialVersionUID = -4115521490413601750L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------

	/** Store the type of the base. */
	private String baseTypeName;
	
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	public CmdBase(String base)
	{
		baseTypeName = base;
	}

	//----------------------------------------------------------------------
	//------- Overridden methods
	//----------------------------------------------------------------------

	/** Perform the actions when added to the main
	 * RPDL object.
	 * @exception RpdlException is the type has not been declared yet.
	 */
	public void add(RpdlBase main) throws RpdlException
	{
		try {
			RpdlType baseType = main.getType(baseTypeName);
			if (baseType == null)
				throw new RpdlException("Cannot set basetype. The type " + baseTypeName +" is not defined yet!");
			main.setBaseType(baseType);
		} catch (RpdlException re) {
			re.fillOrigin(getOrigin());	// update origin if necessary
			throw re;
		}
	}
	
	public String toString() {
		return "CmdBase: " + baseTypeName;
	}
}