package de.mutschler.rpdl.command;

import de.mutschler.rpdl.*;
import de.mutschler.rpdl.entity.*;
import java.util.*;

public class CmdUnlink extends RpdlCommand implements java.io.Serializable
{
	static final long serialVersionUID = -763121822978322785L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------
	/** Unlink from this object. */
	private String fromName;
	/** Unlink to this object. */
	private String objName;
	
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	public CmdUnlink(String objn, String from)
	{
		this.fromName = from;
		this.objName = objn;
	}

	//----------------------------------------------------------------------
	//------- Overridden methods
	//----------------------------------------------------------------------

	/** Perform the actions when added to the main
	 * RPDL object.
	 */
	public void add(RpdlBase main) throws RpdlException
	{
		try {
			RpdlObject fromObj = main.getObject(fromName);
			if (fromObj == null)
				throw new RpdlException("Object " + fromName + " not defined!", getOrigin());

			RpdlObject obj   = main.getObject(objName);
			if (obj == null)
				throw new RpdlException("Object " + objName + " not defined!", getOrigin());

			fromObj.unlink(obj);
		} catch (RpdlException re) {
			re.fillOrigin(getOrigin());	// update origin if necessary
			throw re;
		}
	}
	
	public String toString() {
		return "CmdUnlink: " + objName + " FROM " + fromName;
	}
}