package de.mutschler.rpdl.command;

import de.mutschler.util.LogObj;
import de.mutschler.rpdl.*;

/**
 * This is the superclass for all Command-blocks used in
 * rpdl. a complete command is packed into this kind of structure
 */
public abstract class RpdlCommand extends LogObj
{
	/** Perform the actions when added to the main
	 * RPDL object.
	 */
	public abstract void add(RpdlBase main) throws RpdlException;

	//-------------------
	// Origin handling
	private Origin origin = null;
	/** Get the origin of this command. */
	public Origin getOrigin() {return origin;}
	/** Set the origin of this command. */
	public void setOrigin(Origin o) {origin=o;}
}