package de.mutschler.rpdl.entity;

import java.util.*;
import de.mutschler.util.*;
import de.mutschler.rpdl.basicvalue.BasicValue;
import de.mutschler.rpdl.*;

/**
 * This class represents a mathematical calculation
 * of two formulas
 */

public class FormulaConst extends RpdlFormula implements java.io.Serializable
{
	static final long serialVersionUID = 5981046836055479672L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------
	private BasicValue value;
	
	public FormulaConst(BasicValue t) {
		this.value = t;
	}
	
	//----------------------------------------------------------------------
	//------- Methods for interface RpdlFormula
	//----------------------------------------------------------------------
	
	/**
	 * Perform a calculation, and return the result.
	 */
	public BasicValue calc(RpdlBase main, RpdlObject obj) throws RpdlException {
		return value;
	}

	/**
	 * Get the type of result.
	 */
	public String getResultType(RpdlBase main, Entity e) {
		return value.getType();
	}

	/**
	 * Get a list of all dependencies for this formula.
	 * This returns an Iterator with objects of type AttrAccess.
	 */
	public Set getDependencies(RpdlBase main, RpdlObject obj) throws RpdlException {
		return new HashSet();
	}

	
	public String toString() {
		return "(const:" + value.toString() + ")";
		//return value.toString();
	}
	
}
