package de.mutschler.rpdl.entity;

import de.mutschler.rpdl.basicvalue.*;
//import de.mutschler.util.LogObj;
import de.mutschler.rpdl.Origin;

public class RpdlAttributeDef extends NamedObj
{
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------
	
	/** The name of the attribute */
//	private String name;

	/** This defines the basictype which the attribute is of. */
	private String type;
	
	/** If this type can be created by throwing dices, this dicevalue describes
	 *  how to do this.
	 */
	private ValueDice defaultValue;
	
	/** A description what this attribute is used for. */
	private String description;

	
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	public RpdlAttributeDef(String name, String t) {
		this(name, t, "");
	}

	public RpdlAttributeDef(String name, String t, String desc) {
		this(name, t, new ValueDice("0"), desc);
	}

	public RpdlAttributeDef(String name, String t, ValueDice def, String desc) {
		super(name);
		type = t;
		defaultValue = def;
		description = desc;
	}
	
	//----------------------------------------------------------------------
	//------- Accessors
	//----------------------------------------------------------------------
	
	/** Get the type of the attribute. CLone this, if you want to use it for storing values. */
	public String getType() {return type;}

	/** Get the dice value for creating a randomized value for this type of attribute */
	public ValueDice getDefaultValue() {return defaultValue;}
	
	/** Get the description for this attribute. */
	public String getDescription() {return description;}

	//----------------------------------------------------------------------
	//------- Overridden system methods
	//----------------------------------------------------------------------
	
	public String toString() {
		StringBuffer sb = new StringBuffer(30);
		sb.append("AttributeDef:");
		sb.append(" type=").append(getType());
		sb.append(" name=").append(getName());
		if (getDefaultValue() != null)
			sb.append(" def=").append(getDefaultValue());
		if (getDescription() != null)
			sb.append(" desc=").append(getDescription());
		return sb.toString();			
	}
}