package de.mutschler.rpdl.fileimport;

import de.mutschler.rpdl.Origin;
import java.io.File;

public class FileOrigin extends Origin implements java.io.Serializable
{
	static final long serialVersionUID = 8804226767428497044L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------

	private File file;	
	private int line;
	private int column;
	
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	public FileOrigin(File file, int line, int col)
	{
		this.file = file;
		this.line = line;
		this.column = col;
	}

	//----------------------------------------------------------------------
	//------- Accessor(s)
	//----------------------------------------------------------------------
	public File getFile()	{return file;}
	public int getLine()	{return line;}
	public int getColumn()	{return column;}


	//----------------------------------------------------------------------
	//------- Overridden methods
	//----------------------------------------------------------------------

	/**
	 * Just get the info-string of the origin.
	 * The format is "<file>":<line>:<pos>
	 */
	public String getOrigin() {
		return "\"" + file.getPath() + "\":" + line; // + ":" + column;
	}
	
}