package de.mutschler.rpdl.statement;

import de.mutschler.rpdl.entity.RpdlFormula;
import de.mutschler.rpdl.entity.*;
import de.mutschler.util.StringUtil;
import java.util.*;


public class Stmt_Event extends Stmt implements java.io.Serializable
{
	static final long serialVersionUID = 4253277105283761289L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------
	
	/** The list of statements to execute when a change of the
	 * the attribute happens. */
	private List statements = new LinkedList();
	
	/** The attribute to listen to. */
	private FormulaAttribute attribute;
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	/**
	 * Create a new event statement.
	 * @param the attribute to observe
	 */

	public Stmt_Event(FormulaAttribute attr) {
		super();
		this.attribute = attr;
	}

	//----------------------------------------------------------------------
	//------- Accessors
	//----------------------------------------------------------------------

	/** Set the list of statements. */
	public void setStatements(List stmts) {stmts.remove(null); statements = stmts;}
	
	//----------------------------------------------------------------------
	//------- Overridden system methods
	//----------------------------------------------------------------------
	
	public String toString() {
		StringBuffer sb = new StringBuffer(100);
		sb.append("ON CHANGE (" + attribute + ") {\n");
		for (Iterator it = statements.iterator(); it.hasNext(); ) {
			sb.append(StringUtil.indent(((Stmt)it.next()).toString()));
			sb.append('\n');
		}
		sb.append("}");
		return sb.toString();
	}
}