
/**
 * @author Michael Mutschler
 * @version 1.0
 */
package de.mutschler.util;

/**
 * This class can be the superclass of other objects. It defines
 * some useful methods for logging.
 */
 
public abstract class LogObj {
	private final String _clsName = getClass().getName();
	public final static String CR = System.getProperty("line.separator");
	
	protected void debug(String s) {
		Log.log(Log.DEBUG, _clsName, s);
	}
	protected void debug(String s, Throwable e) {
		Log.log(Log.DEBUG, _clsName, s, e);
	}
	protected void ddebug(String s) {
		Log.log(Log.DDEBUG, _clsName, s);
	}
	protected void ddebug(String s, Throwable e) {
		Log.log(Log.DDEBUG, _clsName, s, e);
	}
	protected void warn(String s) {
		Log.log(Log.WARN, _clsName, s);
	}
	protected void warn(String s, Throwable e) {
		Log.log(Log.WARN, _clsName, s, e);
	}
	protected void error(String s) {
		Log.log(Log.ERROR, _clsName, s);
	}
	protected void error(String s, Throwable e) {
		Log.log(Log.ERROR, _clsName, s, e);
	}
}