package de.mutschler.util;

import java.util.Iterator;

/**
 * This wraps a single object into an iterator.
 */
public class SingleIterator implements Iterator
{
	private Object obj;	
	
	public SingleIterator(Object o) {
		obj = o;
	}

	public boolean hasNext() {
		return obj != null;
	}
	// return the current object
	public Object next() {
		Object o = obj;
		obj = null;
		return o;
	}
	public void remove() {
		throw new UnsupportedOperationException("Cannot remove single object");
	}
}